leetcode 10 Regular Expression Matching

    xiaoxiao2022-07-02  99

    10. Regular Expression Matching

    Given an input string (s) and a pattern (p), implement regular expression matching with support for '.' and '*'.

    '.' Matches any single character. '*' Matches zero or more of the preceding element.

    The matching should cover the entire input string (not partial).

    Note:

    s could be empty and contains only lowercase letters a-z.p could be empty and contains only lowercase letters a-z, and characters like . or *.

    Example 1:

    Input: s = "aa" p = "a" Output: false Explanation: "a" does not match the entire string "aa".

    Example 2:

    Input: s = "aa" p = "a*" Output: true Explanation: '*' means zero or more of the precedeng element, 'a'. Therefore, by repeating 'a' once, it becomes "aa".

    Example 3:

    Input: s = "ab" p = ".*" Output: true Explanation: ".*" means "zero or more (*) of any character (.)".

    Example 4:

    Input: s = "aab" p = "c*a*b" Output: true Explanation: c can be repeated 0 times, a can be repeated 1 time. Therefore it matches "aab".

    Example 5:

    Input: s = "mississippi" p = "mis*is*p*." Output: false

    动态规划方法:

    1.  P[i][j] = P[i - 1][j - 1], if p[j - 1] != '*' && (s[i - 1] == p[j - 1] || p[j - 1] == '.'); 2.  P[i][j] = P[i][j - 2], if p[j - 1] == '*' and the pattern repeats for 0 times; 3.  P[i][j] = P[i - 1][j] && (s[i - 1] == p[j - 2] || p[j - 2] == '.'), if p[j - 1] == '*' and the pattern repeats for at least 1 times.

    优化就是空间上的优化了,将二维降为一维,就是省略了i;最主要的是dp[i-1][j-1]用pre来保存,要注意i-1和j-1的取值范围,以及取值范围中的值有没有被更新,比如dp[0]是一直没有被更新的,当i>0时,dp[0]应该是false而不是true;当i更新时,pre = dp[i-1][0];所以要记得在每一次j循环结束i更新都要更新pre值。

    class Solution { public: bool isMatch(string s, string p) { int len2 = p.size(); int len1 = s.size(); vector<bool> dp(len2+1,false); dp[0] = true; if(p[0]=='*') dp[1] = true; for(int j = 2; j <= len2; j++) { dp[j] = (p[j-1] == '*' && dp[j-2]); } bool pre; for(int i = 1; i<= len1; i++) { pre = dp[0]; dp[0] = false; for(int j = 1; j <= len2; j++) { bool cur = dp[j]; dp[j] = (pre && (s[i-1] == p[j-1] || p[j-1] == '.')) || (j > 1 && p[j - 1] == '*' && (dp[j - 2] || (s[i - 1] == p[j - 2] || p[j - 2] == '.') && cur)); pre = cur; } return dp[len2]; } };

     

    最新回复(0)